
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux之grub的运行机制及grub修复 / 憋错料</title>

    <meta name="description" content="Linux之grub的运行机制及grub修复 理论区: GNU GRUB(GRand Unified Bootloader简称&quot;GRUB&quot;)是一个来自GNU项目的多操作系统启动程序.GRUB是多启动规范的实现,它允许用户可以在计算机内同时拥有多个操作系统,并在计算机启动时选择希望运行的操作系统.GRUB可用于选择操作系统分区上的不同内核,也可用于向这些内核传递启动参数. 位于磁盘的0磁头(盘面),0磁道,1扇区位置,该位置共计有512Byte,至于前446个字节是grub. 目前,grub现有两个版本,0.x系列被称为是 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Linux之grub的运行机制及grub修复</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>理论区：</strong></p>
<p>GNU GRUB（GRand Unified Bootloader简称“GRUB”）是一个来自GNU项目的多操作系统启动程序。GRUB是多启动规范的实现，它允许用户可以在计算机内同时拥有多个操作系统，并在计算机启动时选择希望运行的操作系统。GRUB可用于选择操作系统分区上的不同内核，也可用于向这些内核传递启动参数。</p>
<p>位于磁盘的0磁头(盘面)，0磁道，1扇区位置，该位置共计有512Byte，至于前446个字节是grub。</p>
<p>目前，grub现有两个版本，0.x系列被称为是grub1，也被称为grub legacy，CentOS5以及CentOS6上用的是0.x系列；1.x系列被称为是grub2，用于CentOS7；目前CentOS6依旧是企业及的主流版本，所以这里我们主要讨论Grub1的工作机制。</p>
<p>Grub的主要功能便是提供选择菜单，加载内核以及转移控制权，但是我们都知道，mbr中仅有446字节共mbr供其使用，想要实现诸多强大的功能这么小的空间是不可能的，所以，grub在CentOS上主要分为三个步骤，stage1，stage1.5和stage2，突破了传统446字节的限制。</p>
<p><strong>☆Stage1</strong>的作用是启动安装在MBR中的bootloader主程序，其作用便是指向stage2，引导stage2运行；</p>
<p><strong>☆Stage1.5</strong>作用为让grub程序能够识别grub2所在的分区。或许你也已经发现，在/boot/grub目录下有诸多以stage1_5结尾的文件，表示各种文件系统所对应的stage1_5，和stage1文件一样，能够让grub识别stage2所在分区的文件不是这些，而是在系统安装时，早已确定了stage2所在目录的文件系统格式，并将与之对应的以stage1_5结尾的文件安装至MBR之后的62个扇区内。</p>
<p><strong>☆Stage2&nbsp; </strong>&nbsp;作用：a、提供菜单、并提供交互式接口；b、加载用户选择的内核或操作系统，并允许传递参数给内核；3、提供菜单保护机制，这三项功能在后续的实验中将得以体现。</p>
<p>首先，我们看一下grub的配置文件，其位于/boot/grub/grub.conf，或/etc/grub.conf链接文件：</p>
<pre>[[email&#160;protected]&nbsp;~]#cat&nbsp;/boot/grub/grub.conf
#&nbsp;注释信息省略
default=0&nbsp;&nbsp;&nbsp;#设定默认引导的内核项，以title排序，第一个title为第0项，第二个title为第1项，以此类推；
timeout=5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#表示5秒内若不动键盘，grub将引导默认内核项
splashimage=(hd0,0)/grub/splash.xpm.gz#菜单背景图片路径
hiddenmenu&nbsp;&nbsp;#表示隐藏grub菜单，要求用户操作键盘才显示菜单，若省略此项表示开启
title&nbsp;CentOS&nbsp;6&nbsp;(2.6.32-504.el6.x86_64)&nbsp;&nbsp;#内核菜单标题
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;root&nbsp;(hd0,0)&nbsp;&nbsp;##内核所在分区，特别注意，此处不是表示根分区的意思
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;kernel&nbsp;/vmlinuz-2.6.32-504.el6.x86_64&nbsp;roroot=/dev/mapper/vg0-root&nbsp;rd_NO_LUKS&nbsp;rd_NO_DM.UTF-8rd_LVM_LV=vg0/swap&nbsp;rd_NO_MD&nbsp;SYSFONT=latarcyrheb-sun16&nbsp;crashkernel=auto&nbsp;rd_LVM_LV=vg0/root&nbsp;&nbsp;KEYBOARDTYPE=pc&nbsp;KEYTABLE=us&nbsp;rhgbcrashkernel=auto&nbsp;quiet&nbsp;rhgb&nbsp;quiet&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;##内核名称及传递给内核的参数
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;initrd/initramfs-2.6.32-504.el6.x86_64.img&nbsp;&nbsp;&nbsp;&nbsp;#ramdisk名称，版本号及发行版本号必须与内核一致</pre>
<p>##特别注意的是，这里的root是Kernel所在的分区，并且分区标识和开机后的硬盘及分区标识不一样，对于grub而言，没有硬盘接口类型之分，对其来讲，一切硬盘全部是以hd标识，而第一个0标识第一块硬盘，第二个0表示第一个分区编号。如果kernel在第二块硬盘上的第3个分区上，则表示为(hd1,2),小括号也不可省略！</p>
<p><strong>实验区：</strong></p>
<p><strong>A</strong><strong>进入单用户模式的操作：</strong></p>
<p>接下来我们看下开机时grub的显示菜单：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvQTEvd0tpb20xWHBXQUd6c1hEekFBQjRLWmR5LTM0ODkzLmpwZw==.jpg" /></p>
<p>开机默认显示这个界面，默认5秒内按下键盘任意键，便会出现如下界面：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvOUQvd0tpb0wxWHBXa3V6REpteEFBRTNwcGhzZnBNODEyLmpwZw==.jpg" /></p>
<p>上图所示可知，grub配置文件中的title便是在这里显示的白色区域标题，根据方框下部的提示可知，e键可编辑此内容，c键可进入交互式模式，a键可添加参数传递给内核，b键启动，我们按e键看看效果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvQTEvd0tpb20xWHBXRDdpT1dfZkFBSFNpUzRmSXJrMTI1LmpwZw==.jpg" /></p>
<p>此时，我们选中kernel项，并在此按e键，便可编辑内核添加参数传递给内核，如果我们的root密码忘记了，或者是系统异常无法进入系统，此处我们可以编辑内核，在内核尾部添加1或者是s或者是single进入单用户模式，如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzIvOUQvd0tpb0wxWHBXblhnTXdQS0FBRXp0a1JGUnFBNjQwLmpwZw==.jpg" /></p>
<p>而后按回车键，接着按b键，便可进入单用户模式</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzIvQTEvd0tpb20xWHBXRnZCbWdHV0FBQkN1dnRMYVo4MjA3LmpwZw==.jpg" /></p>
<p>上面我们提到过，grub提供了菜单加密功能，为了演示效果，我编辑一下grub.conf文件，添加一个title，并添加密码项：</p>
<p>若想给菜单添加密码，需要使用password关键字，可以对编辑加密，也可以对指定内核启动加密，加密可以是明文，但是安全起见，密文密码比较好，并且grub也提供了密码生成工具，具体配置如下图：</p>
<pre>[[email&#160;protected]&nbsp;~]#grub-md5-crypt&nbsp;&nbsp;&nbsp;##交互式MD5密码生成器
Password:&nbsp;&nbsp;&nbsp;&nbsp;##在此输入你想加密的密码
Retype&nbsp;password:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;##重复输入密码
$1$BjkaP$JgcdSQ8V.ZMeM.VXpTFb9/&nbsp;&nbsp;#将此处生成的字符串粘贴到password后面即可</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNzIvOUQvd0tpb0wxWHBXb2loVTNDckFBS0dEMXFRTjZBMTM4LmpwZw==.jpg" /></p>
<p>现在我们重启进入grub菜单：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNzIvQTEvd0tpb20xWHBXR3pnaWlFVkFBRXUxRElBN3ZBOTEzLmpwZw==.jpg" /></p>
<p>提示需要按p键输入密码才能继续往后的设置，并且，新添加的标题也成功显示了。我们键入p键：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvOUQvd0tpb0wxWHBXcDJTaGRZVkFBRTZNZno0QXFrMDYyLmpwZw==.jpg" /></p>
<p>输入密码后，便可以对选中的内核进行编辑了。由于我们给下面的标题添加了password项，表示启动该内核，也需要输入相应的密码，选中test-title回车出现如下所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvQTEvd0tpb20xWHBXSVRDRFhrZUFBQWNRY0xpMXowNDI4LmpwZw==.jpg" /></p>
<p>只有输入密码才能启动该内核。</p>
<p><strong>grub</strong><strong>修复</strong></p>
<p>第一种场景：磁盘无grub，通过其他方式启动的系统，或正常启动后不小心损坏了系统磁盘的mbr中的前446字节：</p>
<p>第一种方法：</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;dd&nbsp;if=/dev/zero&nbsp;of=/dev/sdabs=200&nbsp;count=1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
##我将磁盘开头的200byte用0全部覆盖，即当前我的bootloader已被破坏
1+0&nbsp;records&nbsp;in
1+0&nbsp;records&nbsp;out
200&nbsp;bytes&nbsp;(200&nbsp;B)&nbsp;copied,&nbsp;0.00829572&nbsp;s,24.1&nbsp;kB/s
此时，在不重启系统的情况下，对grub进行修复
[[email&#160;protected]&nbsp;~]#&nbsp;grub-install--root-directory=/&nbsp;/dev/sda
##这里的—root-directory=/表示可以在磁盘上找到/boot目录的位置
Installation&nbsp;finished.&nbsp;No&nbsp;error&nbsp;reported.
This&nbsp;is&nbsp;the&nbsp;contents&nbsp;of&nbsp;the&nbsp;device&nbsp;map//boot/grub/device.map.
Check&nbsp;if&nbsp;this&nbsp;is&nbsp;correct&nbsp;or&nbsp;not.&nbsp;If&nbsp;any&nbsp;ofthe&nbsp;lines&nbsp;is&nbsp;incorrect,
fix&nbsp;it&nbsp;and&nbsp;re-run&nbsp;the&nbsp;script`grub-install‘.
&nbsp;
#&nbsp;this&nbsp;device&nbsp;map&nbsp;was&nbsp;generated&nbsp;by&nbsp;anaconda
(hd0)&nbsp;&nbsp;&nbsp;&nbsp;/dev/sda</pre>
<p>修复成功。</p>
<p>重启后，便可以正常引导开机。</p>
<p>第二种方法：进入grub模式进行修复前提：/boot目录得实现存在，并且stage文件都完好</p>
<pre>[[email&#160;protected]&nbsp;~]#&nbsp;grub&nbsp;&nbsp;&nbsp;&nbsp;##进入grub交互式界面
Probing&nbsp;devices&nbsp;to&nbsp;guess&nbsp;BIOS&nbsp;drives.&nbsp;Thismay&nbsp;take&nbsp;a&nbsp;long&nbsp;time.
&nbsp;
&nbsp;
&nbsp;&nbsp;&nbsp;GNU&nbsp;GRUB&nbsp;&nbsp;version&nbsp;0.97&nbsp;&nbsp;(640K&nbsp;lower&nbsp;/&nbsp;3072K&nbsp;upper&nbsp;memory)
&nbsp;
&nbsp;[Minimal&nbsp;BASH-like&nbsp;line&nbsp;editing&nbsp;is&nbsp;supported.&nbsp;For&nbsp;the&nbsp;first&nbsp;word,&nbsp;TAB
&nbsp;&nbsp;lists&nbsp;possible&nbsp;command&nbsp;completions.&nbsp;Anywhere&nbsp;else&nbsp;TAB&nbsp;lists&nbsp;the&nbsp;possible
&nbsp;&nbsp;completions&nbsp;of&nbsp;a&nbsp;device/filename.]
grub&gt;&nbsp;root&nbsp;(hd0,0)&nbsp;&nbsp;
root&nbsp;(hd0,0)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;##指定boot分区所在位置，和grub.conf中的意义一样
&nbsp;Filesystem&nbsp;type&nbsp;is&nbsp;ext2fs,&nbsp;partition&nbsp;type&nbsp;0x83
grub&gt;&nbsp;setup&nbsp;(hd0)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;##指明将grub安装到那块磁盘上
setup&nbsp;(hd0)
&nbsp;Checking&nbsp;if&nbsp;"/boot/grub/stage1"exists...&nbsp;no
&nbsp;Checking&nbsp;if&nbsp;"/grub/stage1"&nbsp;exists...yes
&nbsp;Checkingif&nbsp;"/grub/stage2"&nbsp;exists...&nbsp;yes
&nbsp;Checking&nbsp;if&nbsp;"/grub/e2fs_stage1_5"exists...&nbsp;yes
&nbsp;Running&nbsp;"embed&nbsp;/grub/e2fs_stage1_5(hd0)"...&nbsp;&nbsp;27&nbsp;sectors&nbsp;are&nbsp;embedded.
succeeded
&nbsp;Running&nbsp;"install&nbsp;/grub/stage1&nbsp;(hd0)(hd0)1+27&nbsp;p&nbsp;(hd0,0)/grub/stage2&nbsp;/grub/grub.conf"...&nbsp;succeeded
Done.</pre>
<p>修复成功，重启便可正常引导开机。</p>
<p>若grub损坏，没有进行修复，便重启了，便会发生如下悲剧，无法开机：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzIvOUQvd0tpb0wxWHBXcldEb1pyTUFBRWx0Q1dXcWprMTkxLmpwZw==.jpg" /></p>
<p>此时，需进入linux的紧急救援模式，使用U盘镜像或光盘镜像引导开机：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzIvQTEvd0tpb20xWHBXSmpoRnc3NkFBRkR0RkE1eWQ4MDc1LmpwZw==.jpg" /></p>
<p>物理机可忽略上一步操作；接下来，设置BIOS开机启动顺序，使用将光盘启动调整到靠前位置，若usb镜像，需将usb调至靠前：虚拟机开机按F2：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzIvQTEvd0tpb20xWHBXS0dTN0J0V0FBR2UycUdoNGhZNzkxLmpwZw==.jpg" /></p>
<p>按F10保存并重启主机：进入如下界面</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNzIvQTEvd0tpb20xWHBXT0NROEZoSEFBS29IVS0tZXVVMTQyLmpwZw==.jpg" /></p>
<p>或者进入上述界面，按Esc键，进入命令行模式输入：linux rescue并回车</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvOUQvd0tpb0wxWHBXenJ5X0ZKdUFBQV83M2ZxOFd3OTIzLmpwZw==.jpg" /></p>
<p>然后一路ok，直到询问是否开启网络服务，若你修复的时候需要网络功能，便选择开启，只单纯修复grub便可不开启：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvQTEvd0tpb20xWHBXVEtpUEI1R0FBQm10RUVhTVFBNDkyLmpwZw==.jpg" /></p>
<p>接下来：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzIvOUQvd0tpb0wxWHBXMlBRQnMzY0FBR1dfX0x3S29jMTA1LmpwZw==.jpg" /></p>
<p>引导程序会检索磁盘是否有安装过的系统分区，并挂载到/mnt/sysimage目录下，选择continue，</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzIvQTEvd0tpb20xWHBXVkh5Wnh4YkFBQ3czRWI2WGdjNTc1LmpwZw==.jpg" /></p>
<p>系统已被找到，并挂载成功，ok继续；</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNzIvOUQvd0tpb0wxWHBXNExneEdCSUFBQms1cVpFRkJRNjU1LmpwZw==.jpg" /></p>
<p>选择启动shell：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNzIvQTEvd0tpb20xWHBXV3F3Y3c0SEFBRXNqY2l1SGswODA2LmpwZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNzIvOUQvd0tpb0wxWHBXNW1Ta2pxQkFBRHF0U09NZ2hFODUwLmpwZw==.jpg" /></p>
<p>进入grub命令行，便可修复。</p>
<p>此时，将光盘移除，重启便可正常引导系统。</p>
<p>第二种情形：开机时，只显示grub&gt; ，并无法正常引导开机：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvOUQvd0tpb0wxWHBXNldEdUp2NkFBQ0RzUWlPSDE4MjMwLmpwZw==.jpg" /></p>
<p>此种情况为grub配置文件丢失，需手动引导开机后重建grub配置文件。操作如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNzIvQTEvd0tpb20xWHBXWkd4ei1KVkFBQzFNY1NuSmc0MjAyLmpwZw==.jpg" /></p>
<p>使用find命令，搜索第一块磁盘第一个分区是否有内核文件，find (hd0,0)/vm按Tab键，如果自动补全表示内核在第一块磁盘的第一个分区上，接着进行如下操作</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNzIvOUQvd0tpb0wxWHBXOEN6ZTM0NkFBRUJKRWUxQ3BjODUzLmpwZw==.jpg" /></p>
<p>之后，便可正常开机，进入系统后重建grub配置文件便可。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-18 23:43:31 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/grub/" title="grub">grub</a>, <a href="https://www.biecuoliao.com/tag/grub%e4%bf%ae%e5%a4%8d/" title="grub修复">grub修复</a>, <a href="https://www.biecuoliao.com/tag/grub%e5%8e%9f%e7%90%86/" title="grub原理">grub原理</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Linux之grub的运行机制及grub修复的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0R2VE50.html" rel="bookmark">Linux硬件资源管理与外设设备使用、系统运行机制及用户管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux硬件资源管理 PCI设备         显卡            $&gt;&gt;dmesg |grep -i vga[    0.000000] Console: colour VGA+ 80x25[    0.262267] vgaarb: device added: PCI:0000:00:0f.0,decodes=io+mem,owns=io+mem,locks=none[    0.262271] vgaarb: loaded[    0.262272] vgaarb: brid			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nE75KM.html" rel="bookmark">linux命令：grub 文件详解及grub修复，系统常见故障修复</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 首先模拟grub损坏,dd if=/dev/zero of=/dev/sda count=1 bs=400   grub引导破坏,但是此时并未重启,可以直接重新安装grub,从而达到恢复grub:   第一种方法:   1.首先输入grub 进入grub命令行 [[email protected] networking]# grub Probing devices to guess BIOS drives. This may take a long time. GNU GRUB  versio			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J8Oab0.html" rel="bookmark">系统启动流程一，运行级别及grub</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系统启动流程,运行级别及grub linux启动流程 POST-BIOS(boot sequence)-MBR(bootloader,446)-Kernel-/sbin/init 内核设计风格 核心:动态加载,内核模块 内核:/lib/modules 单内核:linux 核心:KO (kernelobject) so() 微内核:windows,solaris (线程) chroot根切换,可以把一个临时的目录当根来用 把一个目录作为假根 ldd:显示一个二进制文件依赖于哪些库文件 mkdir			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ezqZv3.html" rel="bookmark">linux运行机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				linux运行机制,主要包括初始化init系统.系统运行级别.系统关闭方法.下图为系统运行流程图.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZanVd0.html" rel="bookmark">在Linux环境直接复移动硬盘上的GRUB</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				手头有一块用了10年的旧移动硬盘,其中安装了Debian系统,从低版本一直升级到现在的9已经用了很长时间.前不久正连着那块硬盘跑着Debian修改文件的时候,由于一个本可避免的意外震动了数据线,瞬间连接中断.后果不必说,自然是系统无法再读写磁盘数据各种I/O错误不能进行任何工作.关机重启后,移动硬盘的启动项从BIOS快捷菜单里消失,成了一个无引导的普通磁盘. 将移动硬盘连接到运行openSUSE的笔记本检查,见所有的分区都能正确识别,挂载后所有分区可正常读写,文件全部健在.直接重建GRUB,过程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6y5xG4.html" rel="bookmark">linux  忘记ROOT密码怎么办，以及grub加密</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用Linux忘记ROOT密码怎么办?在物理主机面前重启主机进入单用户模式,修改密码. 一.进入单用户模式, 1.重启机器,在下图界面按任意键 2.在下图界面按e(本案对GRUB加密,需要按P后输入密码) 3.如下图界面,移动光标至第二个选项,按e 4.如下图,在末尾输入1或s或single ,回车后会回到上图,按b引导即进入单用户模式. 二.修改root密码,直接passwd后输入新密码. 三.为grub加密,防止别人接触到物理主机后轻易的修改ROOT密码. 配置grub明文密码,修改grub			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pQG6VM.html" rel="bookmark">Linux系统的快速启动机制（内核切换） 【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.chinaunix.net/xmlrpc.php?r=blog/article&amp;uid=26807463&amp;id=4187846 原文地址:Linux系统的快速启动机制(内核切换) 作者:Renwen0524 快速启动机制:允许通过已经运行的Linux内核的上下文启动另一个Linux内核,不需要经过BIOS.BIOS可能会消耗很多时间,特别是带有众多数量的外设的大型服务器.这种办法可以为经常启动机器的开发者节省很多时间. 1.使用该机制要满足两个基本条件1)内核			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6xDrG3.html" rel="bookmark">Linux开机流程即运行级别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux开机流程 一.概念 1.boot  loader: 领导装载程序,常用的有(Grub, spfdisk) 2.Grub: 是一个多操作系统启动管理器,开机时领导不同系统,windows  linux等 二.开机的流程 1.加载BIOS(basic input output system)的硬件信息,并进行自我测试 2.读取并执行第一个开机装置内MBR(主引导记录扇区)的boot loader即grub  spfdisk 等程序! 3. grub(boot loader)就是一个多操作系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j4NvzG4.html" rel="bookmark">java运行机制详细</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JVM(Java虚拟机)一种用于计算设备的规范,可用不同的方式(软件或硬件)加以实现.编译虚拟机的指令集与编译微处理器的指令集非常类似.Java虚拟机包括一套字节码指令集.一组寄存器.一个栈.一个垃圾回收堆和一个存储方法域. Java虚拟机(JVM)是可运行Java代码的假想计算机.只要根据JVM规格描述将解释器移植到特定的计算机上,就能保证经过编译的任何Java代码能够在该系统上运行. 1.为什么要使用Java虚拟机 Java语言的一个非常重要的特点就是与平台的无关性.而使用Java虚拟机是实			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4pQJMK.html" rel="bookmark" class="title">SVN和Phpstorm</a>
					<div>
						1.在Phpstorm连接Subversion(VCS-&gt;Checkout from Version Control-&gt;Subversion) 2.输入svn地址 3.选择导出文件,进行项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eAGgw0.html" rel="bookmark" class="title">javascript中常用的事件绑定方法</a>
					<div>
						我们要想让 JavaScript 对用户的操作作出响应,首先要对 DOM 元素绑定事件处理函数.所谓事件处理函数,就是处理用户操作的函数,不同的操作对应不同的名称. 在JavaScript中,有三种常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2QEv3.html" rel="bookmark" class="title">rhel 7&period;0 配置centos yum源（2016&sol;12&sol;8），成功！</a>
					<div>
						1.首先查看redhat 7.0系统本身所安装的那些yum 软件包: rpm -qa | grep yum #列出所有已安装的yum包 2.删除这些包: rpm -e *.rpm --nodeps # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41ga9k0.html" rel="bookmark" class="title">head&period;S</a>
					<div>
						1 /* 2 * linux/boot/head.s 3 * 4 * (C) 1991 Linus Torvalds 5 */ 6 7 /* 8 * head.s contains the 32-bi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmlJjV4.html" rel="bookmark" class="title">关于DB-Engines发布了数据库系统使用排名榜单</a>
					<div>
						Rank DBMS Database Model Score Dec  2015 Nov  2015 Dec  2014 Dec  2015 Nov  2015 Dec  2014 1. 1. 1.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lr6KE4.html" rel="bookmark" class="title">mysql乱码问题的解决方案</a>
					<div>
						现象:在向数据库中插入的数据有中文时,报如下错误 原因是:电脑的系统默认编码是gbk,而mysql客户端提供的编码方式是utf8,两种编码不一致导致的,查看当前mysql的编码: show varia ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nzgmo4.html" rel="bookmark" class="title">springMVC整理</a>
					<div>
						Ionic2和angularjs2和angularjs和nosql菜鸟教程一起是做手机的 https://www.bilibili.com/video/av8614724/index_10.html是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M61kzr4.html" rel="bookmark" class="title">自定义print macro，两对括号，单参数macro、指定参数macro、可变参数宏</a>
					<div>
						v1--单参数宏 #define DRV_DEBUG 1 #if DRV_DEBUG #define DRV_PRINT(x) printf(x) #else #define DRV_PRINT(x) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgODm3.html" rel="bookmark" class="title">提问和看不懂</a>
					<div>
						在之前和同学的问答中,我更加倾向于给同学一个keyword,一个链接,一个方向,引导学生自己去解决问题(恩,是因为我懒).在这一过程中,有2个非常重要的问题需要强调: 如何提问 不知道大家是否还想回忆 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jXaPV4.html" rel="bookmark" class="title">Android全局资源访问</a>
					<div>
						package com.example.metrox.l12; import android.support.v7.app.ActionBar; import android.support.v7.a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONK1Z0.html" rel="bookmark" class="title">NSJSONSerialization</a>
					<div>
						简介: NSJSONSerialization 可以将 JSON 转换为 OC 对象或将 OC 对象转为 JSON 数据. 可以被转为 JSON 的对象具有以下属性: 1)对象为 NSArray 或  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J8P2P0.html" rel="bookmark" class="title">使用python编写简单网络爬虫（一）</a>
					<div>
						总算有时间动手用所学的python知识编写一个简单的网络爬虫了,这个例子主要实现用python爬虫从百度图库中下载美女的图片,并保存在本地,闲话少说,直接贴出相应的代码如下: ------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p5JjgM.html" rel="bookmark" class="title">POJ 2449 Remmarguts&amp;&num;39&semi; Date &lpar;第k短路 A&ast;搜索算法模板&rpar;</a>
					<div>
						Remmarguts' Date Time Limit: 4000MS   Memory Limit: 65536K Total Submissions: 22412   Accepted: 6085 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41o5ev0.html" rel="bookmark" class="title">同样的模式进行复制</a>
					<div>
						最近在协议开发的工作,总是做的是同一样的事情,每天总是写的是总一样的代码,特别是基于标准协议的开发,因为它们的数据帧格式是一样,不一样的是它们里面的内容.从开始时大家就想能不能做一个模板出来,在以后的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWNNQ3.html" rel="bookmark" class="title">Java I&sol;O 操作的一些基本知识</a>
					<div>
						1.文件类:File ,也是唯一的单独的文件类.可以对文件进行操作.其方法有:exists(),delete(),idDirectory(),createNewFile(),getName(),get ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AAKXK4.html" rel="bookmark" class="title">动态添加删除网卡 - 每天5分钟玩转 OpenStack（156）</a>
					<div>
						这是 OpenStack 实施经验分享系列的第 6 篇. 在项目实施过程中,经常会有添加删除网卡的需求.比如一个运行数据库的 instance,初始只有一个网卡,数据库服务和备份共用这块网卡,后来为提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AE9py4.html" rel="bookmark" class="title">IOS中数据存储  sqlite3 的应用&comma; 知识点&colon; 数据库句柄 &comma; 单例模式运用&comma; &NewLine;Services服务层&comma;sqlite3&lowbar;open&comma; sqlite3&lowbar;exec&comma; &NewLine;sqlite3&lowbar;prepare&lowbar;v2&comma;sqlite3&lowbar;step等等</a>
					<div>
						相比于服务器端的数据存储,IOS中几种数据存储的技术: (1)XML属性列表 -- PList (2)NSKeyedArchiver 归档 (3)Preference(偏好设置) (4)SQLite3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDNR6e3.html" rel="bookmark" class="title">单纯性与网络流</a>
					<div>
						单纯性模板: 需要b &gt; 0, xi &gt; 0. 1 // 单纯性 2 // n+1 * m+1 矩阵 3 // 1~n 为约束 &lt;= 右值 4 // n+1为目标最大值 5 // 对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dz98e4.html" rel="bookmark" class="title">关于职场新人必看的职场攻略</a>
					<div>
						在郴州找工作的职场新人,可能由于工作经验不风度,在企业需要学习的东西有很多,一开始去上班可能真的是做录资料.整理文件等小事,但是不要忽略这些小事的细节,每一件工作都可以从中发现他存在的价值,以下这几点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6jWZ0.html" rel="bookmark" class="title">版本工具管理之----git</a>
					<div>
						如何查看隐藏文件夹: 如果你看不到.git目录,你需要让隐藏的文件可见.具体做法就是打开一个Terminal窗口,输入以下命令: defaults write com.apple.finder App ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.022 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
